package com.prank.sounds.fart.activity;

import android.annotation.SuppressLint;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.SystemClock;
import android.view.View;

import androidx.appcompat.app.AppCompatActivity;

import com.prank.sounds.fart.R;
import com.prank.sounds.fart.tools.RecorderManager;
import com.prank.sounds.fart.tools.MyUtils;
import com.prank.sounds.fart.databinding.RecordSoundsActBinding;
import com.prank.sounds.fart.topon.AdManager;
import com.prank.sounds.fart.topon.onActionListener;

public class RecorderSoundsAct extends AppCompatActivity {
    private RecordSoundsActBinding binding;
    private long startTime;
    private long elapsedTime;
    private Handler handler = new Handler();
    private Runnable runnable;
    private boolean isCreate = false;

    private RecorderManager recorderManager;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = RecordSoundsActBinding.inflate(getLayoutInflater());
        setContentView(binding.getRoot());

        AdManager.loadAllAd();
        AdManager.showTopOn(this, new onActionListener() {
            @Override
            public void onAction() {

            }
        });

        MyUtils.setStatusBarTextColor(this, true);
        recorderManager = new RecorderManager(this);

        binding.audioTime.setText(R.string.time_init);

        initEvent();
    }

    private void initEvent() {
        binding.back.setOnClickListener(v -> {
            AdManager.showTopOn(this, new onActionListener() {
                @Override
                public void onAction() {
                    finish();
                }
            });
        });
        binding.imMic.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                binding.imMic.setSelected(!binding.imMic.isSelected());
                createSound();
            }
        });
    }

    private void createSound() {
        if (!isCreate) {
            recorderManager.startRecording();
            isCreate = true;
            runnable = new Runnable() {
                @SuppressLint("DefaultLocale")
                @Override
                public void run() {
                    long currentTime = SystemClock.elapsedRealtime();
                    elapsedTime = currentTime - startTime;
                    int milliseconds = (int) (elapsedTime % 1000) / 10;
                    int seconds = (int) (elapsedTime / 1000) % 60;
                    int minutes = (int) (elapsedTime / (1000 * 60)) % 60;
                    binding.audioTime.setText(String.format("%02d : %02d : %02d", minutes, seconds, milliseconds));
                    handler.postDelayed(this, 10);
                }
            };
            startTime = SystemClock.elapsedRealtime();
            handler.post(runnable);
        } else {
            recorderManager.stopRecording();

            handler.removeCallbacks(runnable);
            Intent intent = new Intent(RecorderSoundsAct.this, SaveSoundsAct.class);
            intent.putExtra(SaveSoundsAct.KEY_Time, elapsedTime);
            intent.putExtra(SaveSoundsAct.KEY_Path, recorderManager.getTempFileName());
            intent.putExtra(SaveSoundsAct.KEY_import, 1);
            startActivity(intent);
            finish();
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        handler.removeCallbacks(runnable);
    }
}